/* LICENSE:
Copyright (c) Members of the EGEE Collaboration. 2010.
See http://www.eu-egee.org/partners/ for details on the copyright
holders.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

   http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
implied.
See the License for the specific language governing permissions and
limitations under the License.

END LICENSE */

#ifndef GLITE_CE_CREAM_CLIENT_API_SOAPPROXY_EW
#define GLITE_CE_CREAM_CLIENT_API_SOAPPROXY_EW

#include "glite/ce/cream-client-api-c/cream_client_soapH.h"
#include "glite/ce/cream-client-api-c/cream_client_soapStub.h"

#include <string>
#include <map>

namespace glite {
  namespace ce {
    namespace cream_client_api {
      namespace soap_proxy {
	
	class EventWrapper : public CREAMTYPES__Event {
	
	  //void clone( const CREAMTYPES__Event* other ) throw();
	  void destroy( void ) throw(); 
	  
	  EventWrapper( const CREAMTYPES__Event*) {}
	  EventWrapper& operator=( const CREAMTYPES__Event& ) {return *this;}
	  EventWrapper( const EventWrapper& ) {}
	  EventWrapper( const CREAMTYPES__Event&) {}
	  
	  std::map< std::string, std::string > props;

	protected:

	public:
	  EventWrapper( const std::string& id,
			const std::string& type,
			const time_t T,
			const std::vector<CREAMTYPES__Property*>&);
	  

	  

	  ~EventWrapper() throw();
	  std::string   get_event_id( void ) const { return id; }
	  std::string   get_event_type( void ) const { return type; }
	  time_t        get_event_timestamp( void ) const { return timestamp; }
	  void          get_event_properties( std::map< std::string, std::string >& ) const;
	  
	  std::string   getPropertyValue( const std::string& name ) { return props[name]; }
	};
      }
    }
  }
}

#endif
